<?php
namespace Common\Action;
use Think\Action;
class FuncAction extends Action
{
	/**
     * 添加邮件到队列
     */
    protected function _mail_queue($to, $subject, $body, $priority = 1) {
        $to_emails = is_array($to) ? $to : array($to);
        $mails = array();
        $time = time();
        foreach ($to_emails as $_email) {
            $mails[] = array(
                'mail_to' => $_email,
                'mail_subject' => $subject,
                'mail_body' => $body,
                'priority' => $priority,
                'add_time' => $time,
                'lock_expiry' => $time,
            );
        }
        M('mail_queue')->addAll($mails);
        //异步发送邮件
        $this->send_mail(true);
    }


protected function send_sms($data=array()){
$appid=trim(C('yh_sms_appid'));
$appkey=trim(C('yh_sms_appkey'));
$smsSign=trim(C('yh_sms_sign'));
$phoneNumbers = [$data['phone']];
try {
    $ssender = new \Common\Tqklib\sms\SmsSingleSender($appid, $appkey);
    $params = [$data['code'],$data['webname']];
    $result = $ssender->sendWithParam("86", $phoneNumbers[0], $data['temp_id'],
        $params, $smsSign, "", "");  // 签名参数未提供或者为空时，会使用默认签名发送短信
    $rsp = json_decode($result);
    return $result;
} catch(\Exception $e) {
    return false;
}
	
}


    public function send_mail($is_sync = true) {
        if (!$is_sync) {
            //异步
            session('async_sendmail', true);
            return true;
        } else {
            //同步
            session('async_sendmail', null);
            return D('mail_queue')->send();
        }
    }

    protected function _upload_init($upload) {
        $allow_max = C('yh_attr_allow_size'); //读取配置
        $allow_exts = explode(',', C('yh_attr_allow_exts')); //读取配置
        $allow_max && $upload->maxSize = $allow_max * 1024;   //文件大小限制
        $allow_exts && $upload->allowExts = $allow_exts;  //文件类型限制
        $upload->saveRule = 'uniqid';
        return $upload;
    }

    /**
     * 上传文件
     */
    protected function _upload_old($file, $dir = '', $thumb = array(), $save_rule='uniqid') {
      
        $upload = new UploadFile();
        if ($dir) {
            $upload_path = C('yh_attach_path') . $dir . '/';
            $upload->savePath = $upload_path;
        }
        if ($thumb) {
            $upload->thumb = true;
            $upload->thumbMaxWidth = $thumb['width'];
            $upload->thumbMaxHeight = $thumb['height'];
            $upload->thumbPrefix = '';
            $upload->thumbSuffix = isset($thumb['suffix']) ? $thumb['suffix'] : '_thumb';
            $upload->thumbExt = isset($thumb['ext']) ? $thumb['ext'] : '';
            $upload->thumbRemoveOrigin = isset($thumb['remove_origin']) ? true : false;
        }

        //自定义上传规则
        $upload = $this->_upload_init($upload);
        if( $save_rule!='uniqid' ){
            $upload->saveRule = $save_rule;
        }

        if ($result = $upload->uploadOne($file)) {
            return array('error'=>0, 'info'=>$result);
        } else {
            return array('error'=>1, 'info'=>$upload->getErrorMsg());
        }
    }

	protected function str_mid_replace($string) {
		if (! $string || !isset($string[1])) return $string;
		$len = strlen($string);
		$starNum = floor($len / 2); 
		$noStarNum = $len - $starNum;
		$leftNum = ceil($noStarNum / 2); 
		$starPos = $leftNum;
		for($i=0; $i<$starNum; $i++) $string[$starPos+$i] = '*';

		return $string;
	}

protected function api_yh_publish_update($item)
    {
        $result = $this->api_yh_update_order($item);
		
        return $result;
    }
    

protected function api_yh_update_order($item) {
	$prefix = C(DB_PREFIX);
	$table=$prefix.'order';
	//$sql='select id,uid,integral,nstatus from '.$table.' where (status=1 or status=2) and orderid ="'.$item['orderid'].'" and goods_iid="'.$item['goods_iid'].'" and format('.$table.'.price,2) = format('.$item['price'].',2)';
	$sql='select id,uid,integral,nstatus from '.$table.' where (status=1 or status=2) and orderid ="'.$item['orderid'].'"';
	$res=M()->query($sql);

 if ($item['status']==3 && $res){
	$map=array(
	'id'=>$res[0]['id']
	);
    	
	$data=array(
	'up_time'=>$item['up_time'],
	'status' =>3
	);
$result=M('order')->where($map)->save($data);
if($result){
$map=array(
'id'=>$res[0]['uid'],
'tbname'=>array('neq',1),
'webmaster'=>array('neq',1)
);
if($res[0]['integral']>0 && $res[0]['nstatus']==0){
M('user')->where($map)->save(array(
 'score'=>array('exp','score+'.$res[0]['integral'])
));
}
	return 1;
	}else{
	return 0;
	}
		
		
	}else{
			
		return 0;

        }
     
    }
    
    
  protected function _api_yh_publish_insert($item)
    {
        $result =$this->api_yh_publish_stat($item);
		
        return $result;
    }
    
    
     protected function _api_Scene_publish_insert($item)
    {
        $result =$this->api_Scene_publish_stat($item);
		
        return $result;
    }
    
 protected function api_Scene_publish_stat($item){
	$prefix = C(DB_PREFIX);
	 $table=$prefix.'order';
	//$field='id,(select webmaster_rate from tqk_user where tqk_user.webmaster_pid="'.$item['relation_id'].'" limit 1) as rate ,(select id from '.$table.' where tqk_order.status=1 and tqk_order.orderid ="'.$item['orderid'].'" and tqk_order.goods_iid="'.$item['goods_iid'].'" and format('.$table.'.price,2) = format('.$item['price'].',2) limit 1) as nid';
	$field='id,(select webmaster_rate from tqk_user where tqk_user.webmaster_pid="'.$item['relation_id'].'" limit 1) as rate ,(select id from '.$table.' where  tqk_order.orderid ="'.$item['orderid'].'" limit 1) as nid';
	$ret=M('admin')->field($field)->where('id>0')->limit(1)->find();
	$mod=M('order');
if($ret['nid']<=0 && $item['status']==1){
	
	  $item['status']=1;
	  $item['nstatus']=2;
	  $item['leve1']=$ret['rate'];
	  $item['oid']=md5($item['oid']);
	 $mod->create($item);
      $item_id = $mod->add();
      if ($item_id) {
            return 1;
        } else {
            return 0;
        }
	
}else{
$data['relation_id']	=$item['relation_id'];
$data['leve1']=$ret['rate'];
$data['nstatus']=2;
$data['fuid']='';
$data['guid']='';
$sqlwhere['orderid'] = $item['orderid'];
$res=$mod->where($sqlwhere)->save($data);
if ($res) {
            return 1;
        } else {
            return 0;
        }	
	
}

     
 }
    
    
 protected function api_yh_publish_stat($item){
	$prefix = C(DB_PREFIX);
	 $table=$prefix.'order';
	//$sql='select id from '.$table.' where status=1 and orderid ="'.$item['orderid'].'" and goods_iid="'.$item['goods_iid'].'" and format('.$table.'.price,2) = format('.$item['price'].',2)';
	$sql='select id from '.$table.' where  orderid ="'.$item['orderid'].'"';
	$num=M()->execute($sql);
	$mod=M('order');
if($num<=0 && $item['status']==1){
	
	  $item['status']=1;
	  $item['nstatus']=1;
	  $item['oid']=md5($item['oid']);
		$mod->create($item);
        $item_id = $mod->add();
        if ($item_id) {
            return 1;
        } else {
            return 0;
        }
	
}else{
	
	return 0;
	
}

     
    }
 
    protected function ajaxReturn($status=1, $msg='', $data='', $dialog='') {
        parent::ajaxReturn(array(
            'status' => $status,
            'msg' => $msg,
            'data' => $data,
            'dialog' => $dialog,
        ));
    }

	protected function jsonReturn($data,$type='JSON'){
    	header('Content-Type:application/json; charset=utf-8');
    	exit(json_encode($data));
    }
}